/****************************************************************************

DynAmp (0.4)
by Vendicator (http://pimpin.info/vendicator | vendicator@mail.com)

Bang module for controlling Winamp2 and Winamp3.
Bangs check for a running copy of wa2/wa3, if none found then if a force is defined in
step.rc, and last it analyzes the WinampPath for either winamp.exe/studio.exe (wa2/wa3)
This is done to allow dynamic configurations, where DynAmp handles either wa2 or wa3
without the user having to go through any configuration process.
It also makes replacing geekamp easy, as all commands are named the same.

Winamp2 is handled through messages and Winamp3 by sending keystrokes,
which on rare occations might make WA3 not respond sometimes to commands.

Based on the 1.9.666 Geekamp source code by Azathoth,
which was originally based on GeekMASTER's GEEKAmp.dll source (1.4).

Released under the GPL. Read that document for info.


Config:

DynAmpPlayer [winamp2 / winamp3]:
	Set this to force which control to load

DynAmpOnWA2 !bang
	Bang to be run when a control is loaded for Winamp2
	ie. use this to set a label text such as !AmpLabelSetText "[winampSong]" // prebuilt for wa2

DynAmpOnWA3 !bang
	Bang to be run when a control is loaded for Winamp3,
	ie. use this to set a label text such as !AmpLabelSetText "[windowTitle('Studio')]" // custommade for wa3

WinampStartNormal
	Default = Off
	On opening, Winamp will remain on screen. If this is not set, Winamp defaults to minimizing when run. 
	(This works only with DynAmp bang commands, not running Winamp through any other method)

PlayNotOpen
	Default = Off
	Use this if you don't want DynAmp to start winamp when the !amp_play command is used.

ShowNotOpen
	Default = Off
	Use this if you don't want DynAmp to start winamp when the !amp_show command is used.

LoadFileNotOpen
	Default = Off
	Use this if you don't want DynAmp to start winamp when the !amp_loadfile command is used.

PrefsNotOpen
	Default = Off
	Use this if you don't want DynAmp to start winamp when the !amp_prefs command is used.

PlayPauseNotOpen
	Default = Off
	Use this if you don't want DynAmp to start winamp when the !amp_playpause command is used.

PlaylistNotOpen
	Default = Off
	Use this if you don't want DynAmp to start winamp when the !amp_playlist command is used.


Bangs:
(all these automatically try to identify which player to use)

	!Amp_ScanPlayer			Scans for which player to use wa2/wa3 (is done automatically)

	!Amp_OnTop				Toggles ontop setting
	!Amp_Power				Toggles winamp on/off
	!Amp_PowerOn			Starts winamp/set forground window
	!Amp_PowerOff			Shutdown winamp

	!Amp_Show				Toggles winamp window
	!Amp_Hide				Hides Winamp if already open
	!Amp_Display			Shows Winamp if hidden

	!Amp_Repeat				Toggle repeat
	!Amp_Shuffle			Toggle Shuffle

	!Amp_VolumeDown			Increase volume
	!Amp_VolumeUp			Decrease volume
	!Amp_Rwd5s				Rewind 5s in song
	!Amp_Ffwd5s				Forward 5s in song

	!Amp_Prev				Plays the previous song in playlist
	!Amp_Play				Play, opens winamp if PlayNotOpen hasn't been set
	!Amp_Pause				Pause
	!Amp_Stop				Stop
	!Amp_Next				Plays the next song in playlist
	!Amp_LoadFile			Opens the load file dialog box, opens winamp if FileLoadNotOpen hasn't been set

	!Amp_OpenLoc			Opens the Open Location dialog box
	!Amp_Prefs				Toggles Preferences window
	!Amp_LoadDir			Shows the dialog to add a directory to the playlist

Specific Player commands / does not scan for running player:

Winamp3:
	
	!Amp_CrossFade			Toggle crossfade on/off
	!Amp_ListStart			Moves to the start of the playlist
	!Amp_ListEnd			Moves to the end of the playlist
	!Amp_ReloadSkin			Reloads current skin
	!Amp_DoubleSize			Toggles DoubleSize mode, for some reason wa3 doesn't respond to this
	!Amp_EditID3			Shows dialog so you can add / view the ID3 tags

Winamp2:

	!Amp_StopAfterTrack		Stops playback once the current track is finished
	!Amp_PlayCD				Plays an audio CD
	!Amp_AddToPlaylist		Opens the add to playlist dialog

	!Amp_ReloadSkin			Reloads current skin
	!Amp_EditID3			Shows dialog so you can add / view the ID3 tags
	!Amp_Rewd10s			Rewind currently playing song by 10 seconds
	!Amp_Rewd20s			Rewind currently playing song by 20 seconds
	!Amp_Ffwd10s			Fast forward currently playing song by 10 seconds
	!Amp_Ffwd20s			Fast forward currently playing song by 20 seconds
	!Amp_Eq					Toggles Equaliser window
	!Amp_PlayList			Toggles Playlist editor
	!Amp_Rew				Rewind currently playing track
	!Amp_About				Displays the About dialog for Winamp
	!Amp_StopFade			Stops with fadeout
	!Amp_Repeat				Toggles the Repeat status
	!Amp_Shuffle			Toggles the Shuffle status
	!Amp_MainMenuPopup		Popup the main Winamp Menu
	!Amp_EasyMove			This toggles Easymove mode
	!Amp_JumpToTime			Shows the Jump to Time dialog
	!Amp_JumpToFile			Shows the Jump to File box
	!Amp_Jump10Forward		Move 10 songs forward in the playlist
	!Amp_Jump10Back			Move 10 songs backward in playlist
	!Amp_WindowShade 		This toggles Windowshade mode
	!Amp_StartPlugin		Toggle plugin
	!Amp_PluginSetup		Shows the plugin config dialog
	!Amp_VisSetup			Shows Visualisations Setup
	!Amp_SetVolume <amount>		Set Volume to a number between 0 and 255, 0 being the lowest volume
	!Amp_SetPanning <amount>	Set Panning to a number between 0 and 255, 0 being all left and 255 being all right
	!Amp_ShadePlaylist		Toggle Shade the Playlist
	!Amp_ShadeBoth			Toggle Shade both the main window and the playlist
	!Amp_ToggleBrowser		Toggle the MiniBrowser
	!Amp_SelectSkin			Opens the Skin Selector Dialog
	!Amp_ReloadSkin			Reload the current skin
	!Amp_DoubleSize			Toggles DoubleSize mode
	!Amp_Restart			Restarts Winamp
	!Amp_LoadEQPreset		Show the list of eq presets so that you can change them on the fly
	!Amp_PlayPause			Toggles playing status of Winamp
	!Amp_AddSong <song_title>	Appends song to current playlist
	!Amp_TimeElapsed		Sets Winamp to display the time elapsed on a song
	!Amp_TimeRemaining		Sets Winamp to display the time remaining on a song
	!Amp_ListStart			Moves to the start of the playlist
	!Amp_ListEnd			Moves to the end of the playlist


Not implemented:
!Amp_FileInfo		: Displays a box with the currently playing song in the title, with bitrate, samplerate and channel info shown
!Amp_MovePosition <modifier> <amount> : This moves the current song position forwards or backwards
Examples: 
!Amp_MovePosition + 100 // This will move the current song position forwards 100 seconds
!Amp_MovePosition - 100 // This will move the current song position backwards 100 seconds

ToDo:
	- Add coolplayer, kjofol, sonique1/2, wmp6, wmp7+, musicmatch?
	- Split winamp specific commands from player to wa2/3 to be more dynamic
	- Load a stub (nothing) when defaulting? then how to start player like geekamp?

Changelog:

2002-09-24:
	- Added commands for Winamp2:
	!Amp_StopAfterTrack, !Amp_PlayCD, !Amp_AddToPlaylist

2002-09-23:
	- Source code released
	- Moved some commands from the general section to specific wa2/3 to allow for other players to be added afterwards
	(and not require them to also have things like doublesize etc).
	also these now "player specific" don't scan for which player is loaded
	- Added bang running depending whether the wa2/3 controller is loaded:
	Use DynAmpOnWA2 !bang / DynAmpOnWA3 !bang in step.rc

2002-09-22:
	- Most Winamp3 keys have been done
	- Merged most commands from GeekAmp, only !Amp_FileInfo & !Amp_MovePosition haven't been added

2002-09-21:
	- Started recoding in an OOP layout to support both wa2 & wa3 (and others?)
	- Added bangs first batch of bangs
	
****************************************************************************/

#include "dynamp.h"
#include "log.h"

const char szAppName[] = "DynAmp"; // Our window class, etc
const char rcsRevision[] = "$Revision: 0.4"; // Our Version
const char rcsId[] = "$Id: dynamp.cpp,v 0.4 Exp $"; // The Full RCS ID.
cDynamp *dynamp; // The module


// initialize these static variables
char player::szAmpPath[MAX_LINE_LENGTH];
BOOL player::WinampStartNormal = FALSE;
BOOL player::PlayNotOpen = FALSE;
BOOL player::PlayPauseNotOpen = FALSE;
BOOL player::PlaylistNotOpen = FALSE;
BOOL player::PrefsNotOpen = FALSE;
BOOL player::LoadFileNotOpen = FALSE;
BOOL player::ShowNotOpen = FALSE;
int wa2::position = 0;

//=========================================================
// Initialization and cleanup
//=========================================================
int initModuleEx(HWND ParentWnd, HINSTANCE dllInst, LPCSTR szPath) {
	int code;
	Window::init(dllInst);
	dynamp = new cDynamp(ParentWnd, code);
	return code;
}

void quitModule(HINSTANCE dllInst) {
	delete dynamp;
}


//=========================================================
// Bang commands
//=========================================================


void Bang_ScanPlayer(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
}

void Bang_Forward5s(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->forward5s();
}

void Bang_Rewind5s(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->rewind5s();
}

void Bang_VolumeDown(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->volumeDown();
}

void Bang_VolumeUp(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->volumeUp();
}

// might need special handling, so it's defined in each player
void Bang_PowerOff(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->powerOff();
}

void Bang_Prev(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->prev();
}

void Bang_Play(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->play();
}

void Bang_Pause(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->pause();
}

void Bang_Stop(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->stop();
}

void Bang_Next(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->next();
}

void Bang_Repeat(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->repeat();
}

void Bang_Shuffle(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->shuffle();
}

void Bang_OnTop(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->onTop();
}

void Bang_LoadFile(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->loadFile();
}

void Bang_Prefs(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->prefs();
}

void Bang_OpenLoc(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->openLoc();
}

void Bang_LoadDir(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->loadDir();
}

// general player functions, doesn't need to be made in player files
void Bang_Power(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->power();
}

void Bang_PowerOn(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->powerOn();
}

void Bang_Show(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->show();
}

void Bang_Hide(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->hide();
}

void Bang_Display(HWND caller, LPCSTR args) {
	dynamp->LoadPlayer();
	dynamp->control->display();
}


//=========================================================
// Module code
//=========================================================

// scans for a running player
int cDynamp::ScanPlayer()
{
	if (FindWindow(WC_WINAMP2, NULL))
		return WA2;
	else if (FindWindow(WC_WINAMP3, NULL))
		return WA3;
	else
		return NONE;
}

// checks different step.rc for player, either a force setting, or analyze file in WinampPath
// is only run once at module load (and recycle etc.) to save cpu&disk =)
int cDynamp::stepRCPlayer()
{
	int player = NONE;

	char playerPath[MAX_LINE_LENGTH];
	memset(playerPath, 0, MAX_LINE_LENGTH);

	char playerExe[256];
	memset(playerExe, 0, 256);

	// DynAmpPlayer Winamp2/Winamp3
	if (GetRCString("DynAmpPlayer", playerPath, "", MAX_LINE_LENGTH))
	{
		if (stricmp(playerPath, "winamp2") == 0)
			player = WA2;
		else if (stricmp(playerPath, "winamp3") == 0)
			player = WA3;
	}
	// identify by path .exe
	else
	{
#ifdef DEBUG
		LSLog(LOG_DEBUG, szAppName, "checking path");
#endif
		if (GetRCString("WinampPath", playerPath, "", MAX_LINE_LENGTH))
		{
			strcpy(playerExe, strrchr(playerPath, '\\')+sizeof(char) );

#ifdef DEBUG
			LSLogPrintf(LOG_DEBUG, szAppName, "exe: %s", playerExe);
#endif

			if (stricmp(playerExe, "winamp.exe") == 0)
				player = WA2;
			else if (stricmp(playerExe, "studio.exe") == 0)
				player = WA3;
		}
	}

	return player;
}

// checks which control to load, first run scan, then step.rc, then default it
void cDynamp::LoadPlayer()
{
	int foundPlayer = ScanPlayer();

	if (foundPlayer == NONE)
	{
#ifdef DEBUG
		LSLog(LOG_DEBUG, szAppName, "have to check step.rc for player setting");
#endif
		foundPlayer = usePlayer;
	}

	// load the new control
	if (foundPlayer != NONE)
		LoadControl(foundPlayer);
	else
	{
#ifdef DEBUG
		LSLog(LOG_DEBUG, szAppName, "Defaulting to WA2");
#endif
		LoadControl(WA2);
	}
}

// loads a specific control only if it's different from the current one
void cDynamp::LoadControl(int player = NONE)
{
	// only change if we have a new player
	if (loadedControl != player)
	{
		// delete the old control
		if (control != NULL)
		{
#ifdef DEBUG
			LSLog(LOG_DEBUG, szAppName, "deleting control");
#endif
			delete control;
		}
		
		// save the new control id
		loadedControl = player;

		// load new control
		if (player == WA2)
		{
			control = new wa2();
		}
		else if (player == WA3)
		{
			control = new wa3();
		}
		else
		{
#ifdef DEBUG
			LSLog(LOG_DEBUG, szAppName, "no new control");
#endif
			control = NULL;
		}
	}
#ifdef DEBUG
	else
		LSLog(LOG_DEBUG, szAppName, "control already loaded");
#endif
}

//---------------------------------------------------------
// Module constructor
//---------------------------------------------------------
cDynamp::cDynamp(HWND parentWnd, int& code):
Window(szAppName),
control(NULL),
loadedControl(NONE)
{
	int msgs[] = {LM_GETREVID, 0};
	
	if (!createWindow(WS_EX_TOOLWINDOW, szAppName, WS_POPUP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
		0, 0, 0, 0, parentWnd))
	{
		MessageBox(NULL, "Unable to create window.", szAppName, MB_TOPMOST);
		code = 1;
		return;
	}
	
	SetWindowLong(hWnd, GWL_USERDATA, magicDWord);
	
	SendMessage(hParent, LM_REGISTERMESSAGE, (WPARAM)hWnd, (LPARAM)msgs);

	// save which player the ppl want to use
	usePlayer = stepRCPlayer();

	// load the player, checks for running player etc.
	LoadPlayer();

	// add standard, always active commands
	AddBangCommand("!Amp_ScanPlayer", Bang_ScanPlayer);

	AddBangCommand("!Amp_OnTop", Bang_OnTop);
	AddBangCommand("!Amp_Power", Bang_Power);
	AddBangCommand("!Amp_PowerOn", Bang_PowerOn);
	AddBangCommand("!Amp_PowerOff", Bang_PowerOff);
	AddBangCommand("!Amp_Show", Bang_Show);
	AddBangCommand("!Amp_Hide", Bang_Hide);
	AddBangCommand("!Amp_Display", Bang_Display);

	AddBangCommand("!Amp_Repeat", Bang_Repeat);
	AddBangCommand("!Amp_Shuffle", Bang_Shuffle);

	AddBangCommand("!Amp_VolumeDown", Bang_VolumeDown);
	AddBangCommand("!Amp_VolumeUp", Bang_VolumeUp);
	AddBangCommand("!Amp_Rwd5s", Bang_Rewind5s);
	AddBangCommand("!Amp_Ffwd5s", Bang_Forward5s);

	AddBangCommand("!Amp_Prev", Bang_Prev);
	AddBangCommand("!Amp_Play", Bang_Play);
	AddBangCommand("!Amp_Pause", Bang_Pause);
	AddBangCommand("!Amp_Stop", Bang_Stop);
	AddBangCommand("!Amp_Next", Bang_Next);

	AddBangCommand("!Amp_OpenLoc", Bang_OpenLoc);
	AddBangCommand("!Amp_Prefs", Bang_Prefs);
	AddBangCommand("!Amp_LoadDir", Bang_LoadDir);

	AddBangCommand("!Amp_LoadFile", Bang_LoadFile);

	code = 0;
}

//---------------------------------------------------------
// Module destructor
//---------------------------------------------------------
cDynamp::~cDynamp()
{
	int msgs[] = {LM_GETREVID, 0};
	
	SendMessage(hParent, LM_UNREGISTERMESSAGE, (WPARAM)hWnd, (LPARAM)msgs);

	RemoveBangCommand("!Amp_VolumeDown");
	RemoveBangCommand("!Amp_VolumeUp");
	RemoveBangCommand("!Amp_Ffwd5s");
	RemoveBangCommand("!Amp_Rewd5s");

	RemoveBangCommand("!Amp_OnTop");
	RemoveBangCommand("!Amp_Power");
	RemoveBangCommand("!Amp_PowerOn");
	RemoveBangCommand("!Amp_PowerOff");
	RemoveBangCommand("!Amp_Show");
	RemoveBangCommand("!Amp_Hide");
	RemoveBangCommand("!Amp_Display");

	RemoveBangCommand("!Amp_Repeat");
	RemoveBangCommand("!Amp_Shuffle");

	RemoveBangCommand("!Amp_ScanPlayer");
	RemoveBangCommand("!Amp_Prev");
	RemoveBangCommand("!Amp_Play");
	RemoveBangCommand("!Amp_Pause");
	RemoveBangCommand("!Amp_Stop");
	RemoveBangCommand("!Amp_Next");

	RemoveBangCommand("!Amp_OpenLoc");
	RemoveBangCommand("!Amp_Prefs");
	RemoveBangCommand("!Amp_LoadDir");

	RemoveBangCommand("!Amp_LoadFile");

	// load no control, also frees memory
	LoadControl(NONE);

	destroyWindow();
}


//=========================================================
// Registered messages
//=========================================================

void cDynamp::windowProc(Message& message)
{
	BEGIN_MESSAGEPROC
		MESSAGE(onEndSession,        WM_ENDSESSION)
		MESSAGE(onEndSession,        WM_QUERYENDSESSION)
		MESSAGE(onGetRevId,          LM_GETREVID)
		MESSAGE(onSysCommand,        WM_SYSCOMMAND)
	END_MESSAGEPROC
}

//=========================================================
// Message handlers
//=========================================================
void cDynamp::onEndSession(Message& message)
{
	message.lResult = SendMessage(hParent, message.uMsg, message.wParam, message.lParam);
}

void cDynamp::onGetRevId(Message& message)
{
	char* buf = (char*)(message.lParam);
	
	switch (message.wParam)
	{
	case 0:
		sprintf(buf, "%s %s ", szAppName, &rcsRevision[11]);
		buf[strlen(buf) - 1] = '\0';
		break;
	case 1:
		strcpy(buf, &rcsId[1]);
		buf[strlen(buf) - 1] = '\0';
		break;
	default:
		strcpy(buf, "");
	}
	message.lResult = strlen(buf);
}

void cDynamp::onSysCommand(Message& message)
{
	if (message.wParam == SC_CLOSE)
		PostMessage(hParent, WM_KEYDOWN, LM_SHUTDOWN, 0);
	else
		message.lResult = DefWindowProc(hWnd, message.uMsg, message.wParam, message.lParam);
}

//=========================================================
// Bang command handling
//=========================================================
